Friday, March 8, 2024

[LeetCode] Dota2 Senate

Problem: In the world of Dota2, there are two parties: the Radiant and the Dire.

The Dota2 senate consists of senators coming from two parties. Now the Senate wants to decide on a change in the Dota2 game. The voting for this change is a round-based procedure. In each round, each senator can exercise one of the two rights:

  • Ban one senator's right: A senator can make another senator lose all his rights in this and all the following rounds.
  • Announce the victory: If this senator found the senators who still have rights to vote are all from the same party, he can announce the victory and decide on the change in the game.

Given a string senate representing each senator's party belonging. The character 'R' and 'D' represent the Radiant party and the Dire party. Then if there are n senators, the size of the given string will be n.

The round-based procedure starts from the first senator to the last senator in the given order. This procedure will last until the end of voting. All the senators who have lost their rights will be skipped during the procedure.

Suppose every senator is smart enough and will play the best strategy for his own party. Predict which party will finally announce the victory and change the Dota2 game. The output should be "Radiant" or "Dire".

Example:

Input: senate = "RD"
Output: "Radiant"
Explanation: 
The first senator comes from Radiant and he can just ban the next senator's right in round 1. 
And the second senator can't exercise any rights anymore since his right has been banned. 
And in round 2, the first senator can just announce the victory since he is the only guy in the senate who can vote.
Input: senate = "RDD"
Output: "Dire"
Explanation: 
The first senator comes from Radiant and he can just ban the next senator's right in round 1. 
And the second senator can't exercise any rights anymore since his right has been banned. 
And the third senator comes from Dire and he can ban the first senator's right in round 1. 
And in round 2, the third senator can just announce the victory since he is the only guy in the senate who can vote.


Approach: This problem is little difficult to understand. Its not like typical voting system where if number of R's and more than D's then winner is R. Let's see by an example:

DDRRR

  • First step, D will remove one R(Banning R's right), Now the string is DDRR.
  • Second step, D will remove one R, Now the string is DDR.
  • Third step, R will remove one D, Now the string is DR.
  • Fourth step, D will remove R. Now the string is D.
  • D is clearly winner here.

How can we solve this problem, we become greedy. We know that whoever votes, she will try to remove the nearest opposition. To solve this problem, we will use two queues. One queue for storing indices of D and one queue for storing indices of R. 

Now it's simple, we get the first elements of both queues, remove whichever is greater to simulate greedy approach. Now we need to insert the smaller element again as this problem is circular in nature. We just can insert index + length into queue to simulate circular behavior.


Implementation in C#:

    public string PredictPartyVictory(string senate)
    {
        int length = senate?.Length ?? 0;
        if (length == 0)
        {
            return "";
        }
        Queue<int> rQueue = new Queue<int>();
        Queue<int> dQueue = new Queue<int>();
        for (int i = 0; i < length; ++i)
        {
            if (senate[i] == 'R')
            {
                rQueue.Enqueue(i);
            }
            else
            {
                dQueue.Enqueue(i);
            }
        }
        while (rQueue.Count > 0 && dQueue.Count > 0)
        {
            int rElem = rQueue.Dequeue();
            int dElem = dQueue.Dequeue();
            if (rElem < dElem)
            {
                rQueue.Enqueue(rElem + length);
            }
            else
            {
                dQueue.Enqueue(dElem + length);
            }
        }
        return rQueue.Count > 0 ? "Radiant" : "Dire";
    }

Complexity: O(n)

No comments:

Post a Comment